function [transformer_features_train_edited,Y_train_edited] = SMOTE_transformer(transformer_features_train,Y_train,num2Add)

Var = transformer_features_train';
transformer_features_train2 = array2table(Var);
transformer_features_train2 = addvars(transformer_features_train2, string(Y_train),...
    'NewVariableNames','label');

labels = transformer_features_train2(:,end);
t = tabulate(transformer_features_train2.label);
uniqueLabels = string(t(:,1));
labelCounts = cell2mat(t(:,2));

% num2Add = [1500,0,1500];%450,0,500
algorithm = "Safe-level SMOTE";
k = 10;
newdata = table;
visdataset = cell(length(uniqueLabels),1);

% for each class
for ii=1:length(uniqueLabels)
    
    switch algorithm
        case "SMOTE"
            [tmp,visdata] = mySMOTE(transformer_features_train2,uniqueLabels(ii),num2Add(ii),...
                "NumNeighbors",k, "Standardize", false);
        case "ADASYN"
            [tmp,visdata]  = myADASYN(transformer_features_train2,uniqueLabels(ii),num2Add(ii),...
                "NumNeighbors",k, "Standardize", false);
        case "Borderline SMOTE"
            [tmp,visdata] = myBorderlineSMOTE(transformer_features_train2,uniqueLabels(ii),num2Add(ii),...
                "NumNeighbors",k, "Standardize", false);
        case "Safe-level SMOTE"
            [tmp,visdata] = mySafeLevelSMOTE(transformer_features_train2,uniqueLabels(ii),num2Add(ii),...
                "NumNeighbors",k, "Standardize", false);
    end
    newdata = [newdata; tmp];
    visdataset{ii} = visdata;
end

originallabels = transformer_features_train2.label;
newlabels = newdata.label;
newdata = newdata(:,1:end-1);

transformer_features_train2_SMOTE = table2array(newdata);

transformer_features_train_edited = [transformer_features_train';transformer_features_train2_SMOTE];
Y_train_edited = [Y_train;categorical(newlabels)];


end