function [transformed_features] = get_signal_features(current_header,current_recordings)

header_data = current_header{1,1};
header_data2 = strsplit(header_data,' ');

fs = str2double(header_data2{1,3});

recording_locations={'AV','MV','PV','TV','Phc'};
num_recording_locations=length(recording_locations);

%%% Fix recordings to be as 'AV','MV','PV','TV','Phc'
locations=get_locations(current_header);
num_locations=length(locations);
locations_edited = [{''},{''},{''},{''}];
current_recordings_edited = [{''},{''},{''},{''}];
for j = 1:num_locations

    ind = strmatch(locations{j},recording_locations);
    locations_edited{1,ind} = locations{j};
    current_recordings_edited{1,ind} = current_recordings{j};

end

current_recordings_edited = current_recordings_edited(1:4);
locations_edited = locations_edited(1:4);

%%% Fix less than 4 recordings
   for i = 1:4
       selected_location = locations_edited{1,i};
       if isempty(selected_location) == 1
           if i == 1
              current_recordings_edited{1,i} = current_recordings_edited{1,i+1}; 
              if isempty(current_recordings_edited{1,i}) == 1
                 current_recordings_edited{1,i} = current_recordings_edited{1,i+2}; 
              end
              if isempty(current_recordings_edited{1,i}) == 1
                 current_recordings_edited{1,i} = current_recordings_edited{1,i+3}; 
              end
              if isempty(current_recordings_edited{1,i}) == 1
                 current_recordings_edited{1,i} = current_recordings_edited{1,i+4}; 
              end
           else
              current_recordings_edited{1,i} = current_recordings_edited{1,i-1};
           end
       end
   end

% lengths = single.empty;
% for o = 1:length(current_recordings_edited)  
%     lengths(o,1) = length(current_recordings_edited{1,o});
% end

%%% Extract features per recording
transformed_features = single.empty;
for j = 1:4

    selected_recording = current_recordings_edited{j};
%     selected_recording2 = selected_recording(1:min(lengths));

    selected_length = 160000;
    if length(selected_recording) >= selected_length
       transformed_features(j,:) = selected_recording(1:selected_length);
    else 
       NumSegments = ceil(selected_length/length(selected_recording));
       full_segment = single.empty;
       for p = 1:NumSegments
           full_segment = [full_segment;selected_recording];
       end
       transformed_features(j,:) = full_segment(1:selected_length);
    end     

end
% 
% transformed_features_resampled = single.empty;
% for o = 1:4
% PCG_resampled = butterworth_low_pass_filter(double(transformed_features(o,:)),2,825,4000, false);
% PCG_resampled = butterworth_high_pass_filter(PCG_resampled,2,25,4000);
% transformed_features_resampled(o,:) = PCG_resampled;
% end

transformed_features = normalize(transformed_features,2);

end