classdef globalMadPooling1dLayer < nnet.layer.Layer
        
    methods
        function layer = globalMadPooling1dLayer(args) 
            arguments
                args.Name = "";
            end
    
            % Set layer name.
            layer.Name = args.Name;

            % Set layer description.
            layer.Description = "Global mad pooling 1d layer";
        
            layer.Type = "Global Mad";
        end
        
        function Z = predict(~,X)

%             main_matrix = mean(X,3);
%             main_matrix = main_matrix .* 0;

            for p = 1:size(X,1)
                selected_matrix = X(p,:,:);
%                 selected_matrix = gather(extractdata(selected_matrix));
%                 median_value(p,:) = skewness(selected_matrix,1,3);
                mad_value(p,:) = mad(selected_matrix,0,3);
            end

           Z = mad_value;

           memory = [];
        end

         function [Z, memory] = forward(~,X)
             
%             main_matrix = mean(X,3);
%             main_matrix = main_matrix .* 0;

            for p = 1:size(X,1)
                selected_matrix = X(p,:,:);
%                 selected_matrix = gather(extractdata(selected_matrix));
%                 median_value(p,:) = skewness(selected_matrix,1,3);
                mad_value(p,:) = mad(selected_matrix,0,3);
            end

           Z = mad_value;

           memory = [];
            
         end

         function [dX] = backward(~, X, ~, dZ, ~)
            %   Inputs:
            %   dZ - The derivative of the loss function with respect to the output
            %   of the GlobalAveragePooling layer.
            %   X - The input to the layer.
            %
            %   Output:
            %   dX - The derivative of the loss function with respect to the input
            %   of the global average pooling layer.

            szX = size(X);
            szPool = size(X, 3);
            dX = 1/prod(szPool) * ones(szX) .* dZ;

        end

    end
end
