function [net_LSTM,predictedLabels_LSTM,scores_LSTM] = train_LSTM(transformer_features_train_edited,Y_train_edited,transformer_features_test,Y_test)

transformer_features_train_edited2 = cell.empty;
for p = 1:length(transformer_features_train_edited)
    transformer_features_train_edited2{p,1} = transformer_features_train_edited(p,:);
end
transformer_features_test2 = cell.empty;
for p = 1:length(transformer_features_test)
    transformer_features_test2{p,1} = transformer_features_test(p,:);
end

numFeatures = 1;
numHiddenUnits = 10;
numClasses = 3;
layers = [sequenceInputLayer(numFeatures,Normalization="none")
          bilstmLayer(numHiddenUnits,'OutputMode','last')
          fullyConnectedLayer(numClasses)
          softmaxLayer
          classificationLayer];

options = trainingOptions('adam', ...
    'ExecutionEnvironment','gpu', ...
    'MaxEpochs',35, ...
    'MiniBatchSize',32, ...
    'InitialLearnRate',0.001, ...
    'LearnRateSchedule',"piecewise", ...
    'LearnRateDropFactor',0.1, ...
    'LearnRateDropPeriod',25, ...
    'L2Regularization',0.0001, ...
    'ValidationData',{transformer_features_test2,Y_test}, ...
    'ValidationFrequency',10, ...
    'Shuffle','every-epoch', ...
    'Verbose',false,...
     'Plots','training-progress');
% ,...
%      'Plots','training-progress'
rng('default')
clear net_LSTM
[net_LSTM info] = trainNetwork(transformer_features_train_edited2,Y_train_edited,layers,options);
[predictedLabels_LSTM,scores_LSTM] = classify(net_LSTM,transformer_features_test2,'MiniBatchSize',32);



end