function [net_transformer,predictedLabels_transformer,scores_transformer] = train_transformer(train_signals,Y_train,test_signals,Y_test,weights)

NumFeatures = size(train_signals{1,1},1);
NumSignals = size(train_signals{1,1},1);
[lgraph] = transformer_network_bigger(NumSignals,Y_train,weights);

miniBatchSize = 32;
options = trainingOptions("adam", ...
    ExecutionEnvironment="gpu", ...
    MiniBatchSize=miniBatchSize, ...
    MaxEpochs=90, ...
    SequencePaddingDirection="right", ...
    ValidationData={test_signals,Y_test}, ...
    ValidationFrequency=10, ...
    InitialLearnRate=0.001, ... %% 000001 try decreasing it
    LearnRateSchedule="piecewise", ...
    LearnRateDropFactor=0.1, ...
    LearnRateDropPeriod=65, ...
    L2Regularization=0.0001, ...
    Shuffle='every-epoch', ...
    Plots="training-progress", ...
    Verbose=0);
%       Plots="training-progress", ...
% %   LearnRateSchedule="piecewise", ...
% %     LearnRateDropFactor=0.05, ...
% %     LearnRateDropPeriod=15, ...
rng('default')
clear net_transformer
[net_transformer,info] = trainNetwork(train_signals,Y_train,lgraph,options);
% 
% 
% figure;
% A = activations(net,test_signals,['relu_5',label]);
% rng('default')
% [Y,loss] = tsne(A','Algorithm','exact','Distance','cosine','NumDimensions',2);
% gscatter(Y(:,1),Y(:,2),Y_test,'grk')

[predictedLabels_transformer,scores_transformer] = classify(net_transformer,test_signals,'MiniBatchSize',miniBatchSize);

end